*
* Common routine to process a format specifier, and build an
* output string with appropriate substitutions.
*
* R0	= Pointer to stack variables (format, var1, var2 ...)
* DPTR	= Pointer to output string
*
* Read next character from the format string
_format_ LCALL	?34		Save output pointer
	MOV	DPL,[R0]	Get format LOW
	INC	R0		Advance
	MOV	DPH,[R0]	Get format HIGH
	INC	R0		Advance
?1	CLR	A		Get ZERO
	MOV	R6,A		Clear flags
	MOV	R7,A		Clear width
	MOVX	A,[DPTR]	Read value
	JNZ	?2		Not end of string
* End of format string, return home with the goods
	LCALL	?34		DPTR = output
	CLR	A		Get zero
	MOVX	[DPTR],A	Zero terminate output
	RET
* For special '%' command, process operands
?2	CJNE	A,#'%',?11	Not a special character
	INC	DPTR		Advance to next
	MOVX	A,[DPTR]	Get following char
* If '-', left justify
	CJNE	A,#'-',?3	No a minus
	ORL	?R7,#%10000000	Set left justify bit
	INC	DPTR		Advance to next
	MOVX	A,[DPTR]	Get next char
* If leading '0', zero fill
?3	CJNE	A,#'0',?4	Zero fill
	ORL	?R7,#%01000000	Set ZERO FILL bit
* Evaluate the field width
?4	ADD	A,#-'0'		Convert to zero
	CJNE	A,#10,*+3	Compare with no corrution
	JNC	?5		Exit
	XCH	A,R6		Get width, save char
	MOV	B,#10		*10
	MUL			Get new width
	ADD	A,R6		Include new value
	MOV	R6,A		Copy back
	INC	DPTR		Advance
	MOVX	A,[DPTR]	Get next char
	SJMP	?4		And proceed
* Test for the various special characters
?5	MOVX	A,[DPTR]	Get char back
* 'd' - decimal number
	CJNE	A,#'d',?7	No, try next
	MOV	A,[R0]		Get LOW value
	INC	R0		Advance
	MOV	B,[R0]		Get HIGH value
	JNB	B.7,?6		Not negative
	ORL	?R7,#%00100000	Set '-' output flag
	LCALL	?neg		Negate it
	MOV	[R0],B		Resave LOW
?6	DEC	R0		Advance
	MOV	[R0],A		Resave LOW
	SJMP	?8		And proceed
* 'u' - Unsigned number
?7	CJNE	A,#'u',?9	No, try next
?8	ORL	?R7,#10		Indicate base 10 number
	SJMP	?14		And proceed
* 'x' - Hexidecimal number
?9	CJNE	A,#'x',?10	No, try next
	ORL	?R7,#16		Indicate base 16 number
	SJMP	?14
* 'o' - Octal number
?10	CJNE	A,#'o',?13	No, try next
	ORL	?R7,#8		Indicate base 8	number
	SJMP	?14
* Nothing special, write the character out
?11	LCALL	?34		DPTR = Output
	MOVX	[DPTR],A	Write into output buffer
	INC	DPTR		Advance to next char
* Swap back to format string, advance & process next char
?12	LCALL	?34		DPTR = Input
	INC	DPTR		Skip to next char
	SJMP	?1		Back for next
* 'b' - Binary number
?13	CJNE	A,#'b',?22	No, try next
	ORL	?R7,#2		Indicate base 2 number
* Convert numbers into string (on stack)
?14	MOV	R2,#0		Count of digits
?15	PUSH	?R4		Save R4
	PUSH	?R5		Save R5
	PUSH	?R6		Save R6
	PUSH	?R7		Save R7
	MOV	R3,?R7		Get flags
	ANL	?R3,#%00011111	Save only number base
	MOV	R4,#0		Zero high
	MOV	A,[R0]		Get LOW value
	INC	R0		Advance
	MOV	B,[R0]		Get HIGH value
	LCALL	?div		Perform division
	MOV	[R0],B		Save HIGH
	DEC	R0		Backup
	MOV	[R0],A		Save LOW
	MOV	A,R5		Get remainder
	POP	?R7		Restore R7
	POP	?R6		Restore R6
	POP	?R5		Restore R5
	POP	?R4		Restore R4
	ADD	A,#'0'		Convert to ASCII
	CJNE	A,#$3A,*+3	Hex digit?
	JC	?16		No, its OK
	ADD	A,#7		Convert to ALPHANUMERIC
?16	PUSH	A		Save it
	INC	R2		Advance count
	MOV	A,[R0]		Get result
	ORL	A,B		More digits?
	JNZ	?15		Yes, do them
	LCALL	?34		Set DPTR to output
	MOV	R1,?R2		Save length for unstack
* If number was negative, output '-'
	MOV	A,R7		Get flags
	JNB	A.5,?17		Not minus
	MOV	A,#'-'		Get minus sign
	MOVX	[DPTR],A	Write it out
	INC	DPTR		Advance output
	INC	R2		Advance size (for pad)
* Unstack the number into the output buffer
?17	LCALL	?35		Pad the field
?18	POP	A		Get char
	MOVX	[DPTR],A	Write it
	INC	DPTR		Advance
	DJNZ	R1,?18		Do them all
* If Left justify, pad with spaces
?19	INC	R0		Advance pointer
	INC	R0		To next stack variable
?20	MOV	A,R7		Get flags
	JNB	A.7,?12		No left justify
?21	MOV	A,R2		Get width
	CLR	C		Insure no borrow
	SUBB	A,R6		Calculate remainding
	JNC	?12		Already there
	MOV	A,#' '		Get output
	MOVX	[DPTR],A	Place in output buffer
	INC	DPTR		Advance output
	INC	R2		Advance size
	SJMP	?21		Do them all
* 'c' - Single character
?22	CJNE	A,#'c',?24	No, try next
	MOV	R2,1		Length is one
	LCALL	?34		Swap out
	LCALL	?35		Right justify
	MOV	A,[R0]		Get value
?23	MOVX	[DPTR],A	Write it
	INC	DPTR		Advance output
	SJMP	?19		Output
* 's' - External string
?24	CJNE	A,#'s',?29	No, try next
	PUSH	DPL		Save format LOW
	PUSH	DPH		Save format HIGH
	MOV	DPL,[R0]	Get string LOW
	INC	R0		Advance
	MOV	DPH,[R0]	Get string HIGH
	MOV	R2,#0		Assume zero length
?25	MOVX	A,[DPTR]	Get char
	JZ	?26		And proceed
	INC	DPTR		Advance string
	INC	R2		Advance count
	SJMP	?25		Do till done
?26	MOV	DPH,[R0]	Get HIGH string
	DEC	R0		Backup
	MOV	DPL,[R0]	Get LOW string
	LCALL	?34		DPTR = output
	LCALL	?35		Right justify
?27	LCALL	?34		DPTR = string
	MOVX	A,[DPTR]	Get a char
	INC	DPTR		Advance
	LCALL	?34		DPTR = output
	JZ	?28		And proceed
	MOVX	[DPTR],A	Write to string
	INC	DPTR		Advance
	SJMP	?27		Do them all
?28	POP	?R5		Restore HIGH format
	POP	?R4		Restore LOW format
	SJMP	?19		And proceed
* 'i' - Internal string
?29	CJNE	A,#'i',?33	No, try next
	MOV	?R1,[R0]	Get string address
	MOV	R2,#0		Assume zero length
?30	MOV	A,[R1]		Get char
	JZ	?31		End of string
	INC	R1		Advance string
	INC	R2		Advance count
	SJMP	?30		Do them all
?31	LCALL	?34		DPTR = output
	LCALL	?35		Right justify
	MOV	?R1,[R0]	Reset string
?32	MOV	A,[R1]		Get string
	JZ	?19		End of string
	MOVX	[DPTR],A	Save it
	INC	R1		Advance string
	INC	DPTR		Advance output
	SJMP	?32		Do it all
* Unknown, just output this character
?33	MOV	R1,A		Save it
	MOV	R2,#1		Single
	LCALL	?34		Get chars
	LCALL	?35		Right justify
	MOV	A,R1		Get back
	SJMP	?23		Write & continue
*
* Exchange the input and output pointers (DPTR <-> R4-5)
*	
?34	XCH	A,R5
	XCH	A,DPH
	XCH	A,R5
	XCH	A,R4
	XCH	A,DPL
	XCH	A,R4
	RET
*
* Pad the input field with the proper character
*
?35	MOV	A,R6		Get width
	JZ	?38		No justification
	MOV	B,R7		Get pad value
	JB	B.7,?38		Left justify, do nothing
	PUSH	?R2		Save R2
?36	MOV	A,R2		Get width
	CLR	C		Insure no borrow
	SUBB	A,R6		Compare against limit
	JNC	?37		We are already there
	MOV	A,#' '		Assume space
	JNB	B.6,*+5		Assumption correct
	MOV	A,#'0'		Get leading zeros
	MOVX	[DPTR],A	Write it out
	INC	DPTR		Advance output
	INC	R2		Advance count
	SJMP	?36		do them all
?37	POP	?R2		Restore R2
?38	RET
